<?php

namespace Arch\Listeners;

use Arch\Logging\LogstashFormatter;
use Illuminate\Database\Events\QueryExecuted;
use Monolog\Handler\StreamHandler;
use Monolog\Logger;

class QueryListener
{

    protected $logger;

    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
        $this->logger = new Logger(env('APP_NAME', 'APP_NAME'));
        $handler = new StreamHandler(storage_path('/logs/sql.log'));
        $handler->setFormatter(new LogstashFormatter());
        $this->logger->pushHandler($handler);
    }

    /**
     * Handle the event.
     *
     * @param  QueryExecuted $event
     * @return void
     */
    public function handle(QueryExecuted $event)
    {
        if (env('APP_DEBUG')) {
            $sql = str_replace("?", "'%s'", $event->sql);
            $this->logger->debug(vsprintf($sql, $event->bindings), ['conn' => $event->connectionName, 'time' => $event->time.'ms']);
        }
    }

}
